<template>
    <div>
        <div v-if="loading" class="d-flex justify-content-center align-middle svg-loader-component">
            <svg ref="logo" class="svg-container align-middle" id="Capa_1" data-name="Capa 1" xmlns="http://www.w3.org/2000/svg"
                viewBox="0 0 194.11 196.11" style="width: 7%; display: 'flex';">
                <ellipse class="cls-1  animate" cx="96.73" cy="6.91" rx="6.35" ry="6.91" />
                <ellipse class="cls-2 animate2  animate" cx="222.93" cy="51.41" rx="6.35" ry="6.91"
                    transform="translate(-155.52 17.88) rotate(-15)" />
                <ellipse class="cls-1  animate" cx="221.63" cy="227.5" rx="6.91" ry="6.35"
                    transform="translate(-205.29 341.12) rotate(-75)" />
                <ellipse class="cls-2 animate2  animate" cx="95.38" cy="189.21" rx="6.35" ry="6.91" />
                <ellipse class="cls-1  animate" cx="268.81" cy="227.85" rx="6.35" ry="6.91"
                    transform="matrix(0.97, -0.26, 0.26, 0.97, -199.62, 35.77)" />
                <ellipse class="cls-2 animate2  animate" cx="290.86" cy="218.9" rx="6.35" ry="6.91"
                    transform="translate(-220.3 133.19) rotate(-30)" />
                <ellipse class="cls-2 animate2  animate" cx="309.85" cy="204.56" rx="6.35" ry="6.91"
                    transform="translate(-203.7 237.44) rotate(-45)" />
                <ellipse class="cls-1  animate" cx="324.47" cy="185.79" rx="6.35" ry="6.91"
                    transform="translate(-148.47 332.32) rotate(-60)" />
                <ellipse class="cls-1  animate" cx="333.74" cy="163.87" rx="6.35" ry="6.91"
                    transform="translate(-60.74 402.25) rotate(-75)" />
                <ellipse class="cls-2 animate2  animate" cx="187.21" cy="98.73" rx="6.91" ry="6.35" />
                <ellipse class="cls-1  animate" cx="334.09" cy="116.69" rx="6.91" ry="6.35"
                    transform="translate(-168.63 48.87) rotate(-15)" />
                <ellipse class="cls-2 animate2  animate" cx="325.14" cy="94.64" rx="6.91" ry="6.35"
                    transform="translate(-153.57 133.68) rotate(-30)" />
                <ellipse class="cls-2 animate " cx="310.8" cy="75.65" rx="6.91" ry="6.35"
                    transform="translate(-112.28 200.35) rotate(-45)" />
                <ellipse class="cls-1  animate2" cx="292.03" cy="61.03" rx="6.91" ry="6.35"
                    transform="translate(-56.65 241.84) rotate(-60)" />
                <ellipse class="cls-1  animate" cx="270.11" cy="51.76" rx="6.91" ry="6.35"
                    transform="translate(0.39 257.7) rotate(-75)" />
                <ellipse class="cls-2 animate2  animate" cx="97.06" cy="29.4" rx="4.83" ry="5.39" />
                <ellipse class="cls-1  animate" cx="229.19" cy="73.25" rx="4.83" ry="5.39"
                    transform="translate(-160.96 20.24) rotate(-15)" />
                <ellipse class="cls-2 animate2  animate" cx="228.79" cy="205.17" rx="5.39" ry="4.83"
                    transform="translate(-178.42 331.49) rotate(-75)" />
                <ellipse class="cls-1  animate" cx="96.64" cy="165.98" rx="4.83" ry="5.39" />
                <ellipse class="cls-1  animate" cx="264.14" cy="205.28" rx="4.83" ry="5.39"
                    transform="translate(-193.94 33.79) rotate(-15)" />
                <ellipse class="cls-2 animate2  animate" cx="280.63" cy="198.51" rx="4.83" ry="5.39"
                    transform="translate(-211.47 125.34) rotate(-30)" />
                <ellipse class="cls-1  animate" cx="294.8" cy="187.7" rx="4.83" ry="5.39"
                    transform="translate(-196.19 221.86) rotate(-45)" />
                <ellipse class="cls-2 animate  animate" cx="305.7" cy="173.59" rx="4.83" ry="5.39"
                    transform="translate(-147.29 309.97) rotate(-60)" />
                <ellipse class="cls-2 animate2  animate" cx="312.57" cy="157.14" rx="4.83" ry="5.39"
                    transform="translate(-69.92 376.82) rotate(-75)" />
                <ellipse class="cls-1  animate" cx="165.14" cy="97.9" rx="5.39" ry="4.83" />
                <ellipse class="cls-2 animate2  animate" cx="312.68" cy="121.79" rx="5.39" ry="4.83"
                    transform="translate(-170.68 43.51) rotate(-15)" />
                <ellipse class="cls-1  animate" cx="305.91" cy="105.3" rx="5.39" ry="4.83"
                    transform="translate(-161.48 125.49) rotate(-30)" />
                <ellipse class="cls-1  animate2" cx="295.1" cy="91.12" rx="5.39" ry="4.83"
                    transform="translate(-127.81 193.78) rotate(-45)" />
                <ellipse class="cls-2 animate  animate" cx="280.99" cy="80.23" rx="5.39" ry="4.83"
                    transform="translate(-78.8 241.88) rotate(-60)" />
                <ellipse class="cls-1  animate" cx="264.54" cy="73.36" rx="5.39" ry="4.83"
                    transform="translate(-24.6 268.32) rotate(-75)" />
                <ellipse class="cls-2  animate2" cx="97.35" cy="143.29" rx="4.07" ry="4.63" />
                <ellipse class="cls-1 animate2" cx="96.77" cy="52.19" rx="4.07" ry="4.63" />
                <ellipse class="cls-1 animate2  " cx="269.9" cy="178.62" rx="4.07" ry="4.63"
                    transform="translate(-202.96 117.31) rotate(-30)" />
                <ellipse class="cls-1 animate " cx="286.47" cy="161.84" rx="4.07" ry="4.63"
                    transform="translate(-146.74 287.43) rotate(-60)" />
                <ellipse class="cls-2 animate2   " cx="142.61" cy="97.45" rx="4.63" ry="4.07" />
                <ellipse class="cls-1 animate2 " cx="286.18" cy="116.28" rx="4.63" ry="4.07"
                    transform="translate(-169.61 117.1) rotate(-30)" />
                <ellipse class="cls-1 animate  " cx="269.4" cy="99.72" rx="4.63" ry="4.07"
                    transform="translate(-101.47 241.59) rotate(-60)" />
                <ellipse class="cls-2 animate2 " cx="202.88" cy="218.9" rx="6.91" ry="6.35"
                    transform="translate(-237.95 243.58) rotate(-60)" />
        
                <path class="cls-3 animate-prov"
                    d="M231.3,141.19c0-6.42,0-12.84,0-19.26,0-2.7,1.19-4.24,3.84-3.85,4.59.66,8.09-1.21,11.13-4.26s5.61-2.64,8.78-.2c4.33,3.33,8.88,6.38,12.79,10.24,1.69,1.67,2.88,3.37,1.42,6a3.36,3.36,0,0,0,1.23,4.7c2,1.3,1.94,2.92,1.45,5a20.52,20.52,0,0,1-26.36,14.58c-5.35-1.81-3,2-3.05,7.79,0,2,.14,4.06-.06,6.06-.26,2.68-4.29,4.55-6.5,3-2.43-1.71-4-3.74-3.83-7.09C232.4,157.76,231.3,147.26,231.3,141.19Z"
                    transform="translate(-149.81 -41.57)" />
            </svg> 
        </div>
        <slot></slot>
    </div>
</template>
  
<script setup lang="ts">
import { provide, ref } from 'vue'
import type LoadingClass from "./LoadingClass";

const loading = ref<boolean>(false);

function updateLoading() {
  loading.value = !loading.value;
}

const provided: LoadingClass = {
  loading,
  updateLoading
};

provide('loading', provided)

function show(){
    loading.value = true;
}

function hide(){
    loading.value = false;
}

function showLoading(){
    console.log("Loading....");
}

defineExpose({
    show, hide, showLoading
});

</script>
  
<style socope>
    @import url("./style.css");
</style>